//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                                                                     e-PSI@SAR.mq4 |
//|                                       Copyright  2012, Igor Stepovoi aka TarasBY |
//|                                                                taras_bulba@tut.by |
//|                                                                                   |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|        .  -  |
//|      (TarasBY).      |
//|       ,      .  |
//|         .                            |
//|         ,    - |
//| .                                                             |
//|     ,     ,    |
//|     Skype: TarasBY  e-mail.                          |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
#property copyright "Copyright  2008-12, TarasBY WM R418875277808; Z670270286972"
#property link      "taras_bulba@tut.by"
//IIIIIIIIIIIIIIIIIII==================CONSTANS=================IIIIIIIIIIIIIIIIIIIIII+
#define BULL  0
#define BEAR  1
#define STOP -1
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  *****                   *****                  |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
extern string SETUP_Expert          = "==========    ==========";
extern int    MagicNumber              = 2012;
extern int    NewBarInPeriod           = 1;                // >= 0 -      , -1 -    
extern int    TF_Indicators            = PERIOD_H1;        // ,    
//IIIIIIIIIIIIIIIIIII========== ==========IIIIIIIIIIIIIIIIIIIIII+
#include      <b-PSI@Base.mqh>                             //   
#include      <b-PSI@STOPs_Light.mqh>                      //     
#include      <bc-PSI@SAR_Complete_Light.mqh>              //   
#include      <b-PSI@MM_Light.mqh>                         //   
#include      <b-PSI@NET_Light.mqh>                        //    
#include      <b-PSI@Trail_Stairs.mqh>                     //    ()
#include      <b-PSI@ManagerPA.mqh>                        //      
#include      <b-PSI@Services_Light.mqh>                   //   
#include      <b-PSI@Trade_Light.mqh>                      //    
//IIIIIIIIIIIIIIIIIII======  ======IIIIIIIIIIIIIIIIIIIIII+
double        gda_Lots[2];
int           gia_MyOrders[2], gia_HistoryOrders[3];
string        gs_Info;
bool          gb_VirtSTOPs;                                //      
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  Custom expert initialization function                            |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int init()
{
    int err = GetLastError();
//----
    //----      
    if (!fCheck_ExternParameters()) {bb_OptimContinue = true; return (0);}
    //----    
    fInit_Base (Symbol(), MagicNumber, TF_Indicators, ShowCommentInChart, PrintCom, SoundAlert, CreatVStopsInChart);
    //----     
    if (!fInit_ManagerPA()) return (0);
    //----   
    if (!fInit_STOPs()) return (0);
    //----   
    if (!fInit_Trail()) return (0);
    //----   
    fGet_Statistic (-1);
    //----   MM
    bd_LotsMM = fInit_MM (Order_Lots, MagicNumber);
    //----    
    if (!fInit_NET()) return (0);
    //----      
    bdt_BeginTrade = fGet_TermsTrade (bs_Symbol, MagicNumber, bdt_LastTrade);
    //----   
    fGet_LastErrorInArray (bsa_Comment, "init()", bi_indERR);
//----
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  Custor expert deinitialization function                          |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int deinit()
{
//----
    fMineDeInit();
//----
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|               Custom expert iteration function                                    |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int start()
{
    //----    "" 
    if (fSet_Continue()) return (0);
    //----     
    bdt_BeginNewBar = iTime (bs_Symbol, TF_Indicators, 0);
//----
    int err = GetLastError();
//----
    //----  "" 
    bi_MyOrders = fMyPositions (bd_ProfitCUR, gia_MyOrders, MagicNumber);
    //----   
    fControl_BreakEven (gda_Lots);
    //----  
    fGet_Statistic (PERIOD_D1);
    //----     ( )
    if (ShowCommentInChart) {fCommentInChart (bsa_Comment, fGet_StringManagerPA());}
    //----      ( NewBarInPeriod >= 0)
    if (!fCheck_NewBarInPeriod (NewBarInPeriod)) return (0);
    //----        
    if (fManagerPA (bd_ProfitCUR, bd_Balance, bi_MyOrders > 0))
    {
        bi_MyOrders = 0;
        //----   
        bi_curOrdersInSeries = 0;
        //----      
        bdt_NewBar = bdt_BeginNewBar;
        return (0);
    }
    //----    
    if (bi_MyOrders > 0)
    {
        //----      
        if (!bb_TSProfit)
        {
            //----      
            if (fClose_Control()) return (0);
            //----       
            else fControl_Positions();
        }
    }
    else bi_cntTrades = 0;
    //----        TF_Indicators
    if (bdt_NewBar != bdt_BeginNewBar)
    {      
        //----     
        RefreshRates();
        for (int li_IND = 0; li_IND < 2; li_IND++)
        {bda_Price[li_IND] = fGet_TradePrice (li_IND, bb_RealTrade, bs_Symbol);}
        //----    
        int li_Send = fSend_Control (bi_TREND);
        //----  
        fControl_NET (MagicNumber, gia_HistoryOrders[2], bd_BaseBalance, bd_ProfitCUR, Order_Lots, bd_LotsMM, EXP_Comment, li_Send, bb_IsOpenOrders, SendOnlyOrders, Slippage);
        bdt_NewBar = bdt_BeginNewBar;
    }
    //----   
    fGet_LastErrorInArray (bsa_Comment, "start()", bi_indERR);
//----
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                 |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
bool fClose_Control()
{
//----
    int li_SignalClose;
    if (fGet_SignalClose (bs_Symbol, TF_Indicators, Use_close_IND, li_SignalClose, SignalCloseOnBar, VerificationCloseBars))
    {
        if (gia_MyOrders[li_SignalClose] > 0)
        {
            double ld_Pribul;
            if (fClose_AllOrders (bs_Symbol, MagicNumber, ld_Pribul, li_SignalClose, NBars_LifeMIN, TF_Indicators) > 0)
            {fWrite_Log (StringConcatenate ("   .  = ", bs_sign, DSDig (ld_Pribul)), 4); return (true);}
        }
    }
//----
    return (false);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                           |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fMineDeInit()
{
//----
    if (!bb_RealTrade) GlobalVariablesDeleteAll (bs_NameGV);
    //----   ( )    
    if (bb_VirtualTrade) return (0);
    //----    
    if (ClearALLAfterTrade)
    {
        Comment ("");
        //----     
        fObjectsDeleteAll (bs_NameGV, -1, -1); 
        //----  GV-
        GlobalVariablesDeleteAll (bs_NameGV);
    }
    else
    {
        if (ShowCommentInChart)
        {
            //----   
            fGet_Statistic (-1);
            //----    
            fCommentInChart (bsa_Comment, fGet_StringManagerPA());
        }
    }
    //----   
    for (int li_IND = 0; li_IND < 3; li_IND++)
    {if (ObjectFind ("STOP" + li_IND) == 0) ObjectDelete ("STOP" + li_IND);}
    //---- ""
    Sleep (500);
//----
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//              .                         |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
bool fCheck_ExternParameters()
{
//----
    bs_ERROR = "";
    //----     
    if (!IsTesting() && !IsOptimization()) {if (!IsExpertEnabled()) {return (false);}}
    //----    
    if (!fCheck_ExternParametersSAR()) {return (false);}
    //----   GV- 
    bs_NameGV = StringConcatenate ("SAR[", MagicNumber, "]");
    if (NewBarInPeriod == 0) {NewBarInPeriod = Period();}
    if (TF_Indicators == 0) {TF_Indicators = Period();}
    if (IsOptimization()) {if (DeleteBallastOrders == 1) USE_Dinamic_TP = True;}
    else {if (DeleteBallastOrders == 1) if (!USE_Dinamic_TP)
    {bs_ERROR =  " USE_Dinamic_TP = True  DeleteBallastOrders != 1!!!"; return (false);}}
    //----       
    if (EXP_Comment == "") EXP_Comment = StringSubstr (WindowExpertName(), StringFind (WindowExpertName(), "@") + 1);
    gb_VirtSTOPs = USE_VirtualSTOPs || VirtualTrail_ON;
    //----     
    bdt_NewBar = iTime (Symbol(), TF_Indicators, 0);
//----
    return (true);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//+===================================================================================+
//|***********************************************************************************|
//| :                                                            |
//|***********************************************************************************|
//+===================================================================================+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|          ""                                   |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int fMyPositions (double& fd_Profit,     //    
                  int& ar_MyOrders[],    //   "" 
                  int fi_Magic = -1)     // Magic
{
    int li_total = OrdersTotal(), li_ord = 0;
//----
    //----   
    fd_Profit = 0.0;
    ArrayInitialize (ar_MyOrders, 0);
    ArrayInitialize (gda_Lots, 0);
    if (li_total == 0) {return (0);}
    for (int li_pos = li_total - 1; li_pos >= 0; li_pos--)
    {
        if (!OrderSelect (li_pos, SELECT_BY_POS, MODE_TRADES)) continue;
        if (OrderSymbol() != bs_Symbol) continue;
        if (OrderMagicNumber() != fi_Magic) {if (fi_Magic >= 0) continue;}
        if (OrderType() > 1) continue;
        //----   Profit  
        fd_Profit += (OrderProfit() + OrderSwap() + OrderCommission());
        //----      (BUY/SELL)
        ar_MyOrders[OrderType()]++;
        //----     
        li_ord++;
        //----     
        gda_Lots[OrderType()] += OrderLots();
    }
//----
    return (li_ord);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|         ""                                       |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fControl_Positions()
{
    int    li_Ticket, li_LifeBar, err = GetLastError();
    double ld_Profit;
    bool   lb_NewBar = false;
    static datetime ldt_NewBar = 0;
    datetime ldt_BeginBar = iTime (NULL, TF_STOPs, 0);
//----
    if (ldt_NewBar != ldt_BeginBar) lb_NewBar = true;
    for (int i = OrdersTotal() - 1; i >= 0; i--)
    {
        if (!OrderSelect (i, SELECT_BY_POS, MODE_TRADES)) continue;
        if (OrderSymbol() != bs_Symbol) continue;
        if (OrderMagicNumber() != MagicNumber) if (MagicNumber >= 0) continue;
        if (OrderType() > 1) continue;
        li_Ticket = OrderTicket();
        //----  ""   TF_Indicators 
        li_LifeBar = iBarShift (Symbol(), TF_Indicators, OrderOpenTime());
        //----     
        fGet_MarketInfo (bs_Symbol);
        //----      
        if (fControl_MAXLife (li_LifeBar, NBars_LifeMAX)) continue;
        //----  1-      ,  ,    
        if (!DeleteBallastOrders) if (bi_curOrdersInSeries != 1) {if (bi_curOrdersInSeries != Max_trades + bi_cntTrades) continue;}
        //----    
        if (Virtual_Order_SL != 0 || Virtual_Order_TP != 0 || USE_VirtualSTOPs)
        {
            //----  "" 
            if ((NBars_LifeMIN > 0 && NBars_LifeMIN < li_LifeBar) || NBars_LifeMIN == 0)
            {if (fVirtualSTOPs (li_Ticket, Virtual_Order_SL, Virtual_Order_TP, Slippage)) continue;}
        }
        //----   
        if (lb_NewBar || !GlobalVariableCheck (StringConcatenate (li_Ticket, "_#STOP")))
        {if (fCreat_STOPs (N_STOPs, li_Ticket, bda_Price[OrderType()], TF_STOPs, USE_VirtualSTOPs, (bi_curOrdersInSeries != Max_trades + bi_cntTrades))) continue;}
        //----   
        if (DeleteBallastOrders == 1) if (fDelete_BallastOrders (li_Ticket, Slippage, gb_VirtSTOPs, bi_MyOrders > 1)) {bi_MyOrders--; continue;}
        //----   
        fTrail_Position (li_Ticket, Slippage);
    }
    if (lb_NewBar) ldt_NewBar = ldt_BeginBar;
    //----   
    fGet_LastErrorInArray (bsa_Comment, "fControl_Positions()", bi_indERR);
//----
    return;
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//+===================================================================================+
//|***********************************************************************************|
//| :                                                           |
//|***********************************************************************************|
//+===================================================================================+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                            |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fCommentInChart (string& ar_Comment[],      //   
                      string fs_ManagerPA = "")  //        
{
    static string lsa_Time[], lsa_Comment[], ls_BeginTrade, ls_Conditions, ls_SendOrders = "BUY&SELL",
                  ls_row = "\n",
                  ls_PSI = " PSITarasBY \n";
    static bool   lb_first = true;
    static int    li_size, li_size_CommTime, li_Period = 60;
    string ls_CTRL = "", ls_BLOCK_Comment, ls_Comment = "", ls_TermsTrade,
           ls_Error = "", ls_time = "", ls_sign;
//----
    //----      
    if (lb_first)
    {
        li_Period *= NewBarInPeriod;
        li_size = ArraySize (ar_Comment);
        ArrayResize (lsa_Time, li_size);
        ArrayResize (lsa_Comment, li_size);
        InitializeArray_STR (lsa_Comment, "");
        InitializeArray_STR (lsa_Time, "");
        if (SendOnlyOrders == 0) ls_SendOrders = "BUY"; else if (SendOnlyOrders == 1) ls_SendOrders = "SELL";
        ls_BeginTrade = StringConcatenate ("Terms Trade :: Begin - ", TimeToStr (bdt_BeginTrade));
        ls_Conditions = StringConcatenate ("NewBarInPeriod - ", fGet_NameTF (NewBarInPeriod), " | TF Indicators - ", fGet_NameTF (TF_Indicators), " | TF STOPs - ", fGet_NameTF (TF_STOPs),
        "\niMax trades - ", Max_trades, " | SendOnlyOrders - ", ls_SendOrders, "\n");
        bdt_NewBar = iTime (Symbol(), TF_Indicators, 1);
        bdt_NewBarInPeriod = iTime (Symbol(), NewBarInPeriod, 0);
        lb_first = false;
    }
    //----  
    for (int li_MSG = 0; li_MSG < li_size; li_MSG++)
    {
        //----    
        if (StringLen (ar_Comment[li_MSG]) > 0)
        {
            if (ar_Comment[li_MSG] != lsa_Comment[li_MSG])
            {lsa_Comment[li_MSG] = ar_Comment[li_MSG];}
            if (li_MSG == li_size - 1) {ls_sign = "";} else {ls_sign = " : ";}
            lsa_Time[li_MSG] = StringConcatenate (TimeToStr (bdt_curTime), ls_sign);
            ar_Comment[li_MSG] = "";
        }
        //----   
        if (li_MSG < li_size - 1)
        {if (StringLen (lsa_Comment[li_MSG]) > 0) {ls_Comment = StringConcatenate (ls_Comment, lsa_Time[li_MSG], lsa_Comment[li_MSG], "\n");}}
        //----   
        else if (li_MSG == li_size - 1)
        {
            //----  2     
            if (bdt_curTime > StrToTime (lsa_Time[li_MSG]) + 7200)
            {lsa_Comment[li_MSG] = "";}
            if (StringLen (lsa_Comment[li_MSG]) > 0) {ls_Error = StringConcatenate (ls_row, "ERROR:  ", lsa_Time[li_MSG], "\n", lsa_Comment[li_MSG]);}
        }
    }
    //----      
    ls_time = StringConcatenate ("\nTime :: cur ", TimeToStr (bdt_curTime, TIME_DATE|TIME_SECONDS), " | local ", TimeToStr (TimeLocal(), TIME_MINUTES|TIME_SECONDS));
    if (NewBarInPeriod > 0) {ls_time = StringConcatenate (TimeToStr (bdt_NewBarInPeriod + li_Period), " | ", TimeToStr (bdt_NewBar + TF_Indicators * 60), ls_time);}
    ls_TermsTrade = StringConcatenate (ls_BeginTrade, " | Last - ", TimeToStr (bdt_LastTrade), "\n");
    //----    
    ls_BLOCK_Comment = StringConcatenate (bs_ExpertName, "\n", ls_row, gs_Info, ls_time, "\n",
                 ls_TermsTrade,
                 ls_Conditions,
                 ls_row,
                 //----   
                 "          PROFIT    = ", bs_sign, " ", fSplitField (DoubleToStr (bd_ProfitCUR, 1)), " | ", DoubleToStr (bd_ProfitPercent - 100.0, 1), " % [ ", bi_MyOrders, " | ", gia_MyOrders[0], " / ", gia_MyOrders[1], " ]\n",
                 //----     
                 fs_ManagerPA,
                 "          RESULT    = ", bs_sign, " ", fSplitField (DoubleToStr (bd_Pribul, 1)), " [ ", fSplitField (gia_HistoryOrders[2]), " | ", fSplitField (gia_HistoryOrders[0]), " / ", fSplitField (gia_HistoryOrders[1]), " ]\n",
                 ls_PSI,
                 //----  
                 ls_Comment,
                 //----  
                 ls_Error);//,
    //----      
    Comment (ls_BLOCK_Comment);
//----
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                                 |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fGet_Statistic (int fi_Period = 0,           //   (TF)    
                     bool fb_IsTimeGMT = false)   //   
{
    static datetime ldt_NewBar = 0;
    static int      li_PreHistOrders = 0;
    int      li_ORD, err = GetLastError(), li_Period =  MathMax (0, fi_Period);
    datetime ldt_NewPeriod = iTime (bs_Symbol, li_Period, 0);
//----
    //----    " "
    bdt_curTime = TimeCurrent();
    bd_Balance = AccountBalance();
    bd_Equity = AccountEquity();
    bd_FreeMargin = AccountFreeMargin();
    bd_Margin = AccountMargin();
    if (li_PreHistOrders != OrdersHistoryTotal() || ldt_NewBar != ldt_NewPeriod || fi_Period < 0)
    {
        li_PreHistOrders = OrdersHistoryTotal();
        ldt_NewBar = ldt_NewPeriod;
        //----   
        bd_Pribul = fCalculate_Pribul (gia_HistoryOrders, bs_Symbol, MagicNumber);
    }
    //----        
    fCheckInfo();
    //----   
	 fGet_LastErrorInArray (bsa_Comment, "fGet_Statistic()", bi_indERR);
//----
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                   |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fCheckInfo()
{
    static double ld_preLot = 0.0;
//----
    if (ShowCommentInChart)
    {
        if (ld_preLot != bd_LotsMM)
        {
            string ls_Trail = "", ls_MM, ls_addConditions;
            ls_MM = IIFs (UseMM, StringConcatenate ("MM (", DSDig (bd_LotsMM), ")", fGet_MeansType (MeansType, LotsPercent)), "L: " + DSDig (bd_LotsMM));
            ls_addConditions = StringConcatenate (IIFs ((StringLen (ls_Trail) > 0), ls_Trail, ""),
            IIFs ((StringLen (ls_MM) > 0), " - ", ""),
            IIFs ((StringLen (ls_MM) > 0), ls_MM, ""));
            //----  " - "    ( )
            ls_addConditions = IIFs ((StringFind (ls_addConditions, " - ") == 0), StringSubstr (ls_addConditions, 3), ls_addConditions);
            //----   
            gs_Info = StringConcatenate (bs_NameGV, ":     STOP`s", " [ ", StopLoss, "/", TakeProfit, " | ", Virtual_Order_SL, "/", Virtual_Order_TP, " ]", "\n",
            IIFs ((StringLen (ls_addConditions) > 0), StringConcatenate (ls_addConditions, "\n"), ""),
            "Lots: MIN = ", DSDig (bd_MINLOT), " | MAX = ", DSDig (bd_MAXLOT), " | STEP = ", bd_LOTSTEP, "\n",
            IIFs ((NewBarInPeriod < 0), "   ", " : "));
            ld_preLot = bd_LotsMM;
        }
    }
//---- 
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//+===================================================================================+
//|***********************************************************************************|
//| : TESTER                                                                    |
//|***********************************************************************************|
//+===================================================================================+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|            ""                         |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
bool fSet_Continue()
{
    static bool lb_Continue = true;
//----
    if (!bb_RealTrade)
    {
        //----     ()
        if (NewBarInPeriod >= 0) if (iTime (bs_Symbol, NewBarInPeriod, 0) == 0)
        {fPrintAlert (bs_Symbol, NewBarInPeriod, 0); return (true);}
        if (iTime (bs_Symbol, TF_Indicators, 0) == 0)
        {fPrintAlert (bs_Symbol, TF_Indicators, 1); return (true);}
    }
    //----     
    if (!lb_Continue) return (false);
    if (IsOptimization())
    {
        if (bb_OptimContinue) return (true);
        if (fGet_NumPeriods (TF_Indicators) < 0) {bb_OptimContinue = true; return (true);}
        if (fGet_NumPeriods (NewBarInPeriod) < 0) {bb_OptimContinue = true; return (true);}
        //----  
        if (TrailStairs_ON)
        {
            if (Virtual_Order_TP > 0.0) {if (TrailingStop >= Virtual_Order_TP) {bb_OptimContinue = true; return (true);}}
            else
            {
                if (!USE_VirtualSTOPs) if (N_STOPs == 0)
                {if (TrailingStop >= TakeProfit) {bb_OptimContinue = true; return (true);}}
            }
        }
        if (BreakEven > 0.0)
        {
            if (Virtual_Order_TP > 0.0) {if (BreakEven >= Virtual_Order_TP) {bb_OptimContinue = true; return (true);}}
            else
            {
                if (!USE_VirtualSTOPs) if (N_STOPs == 0)
                {if (BreakEven >= TakeProfit) {bb_OptimContinue = true; return (true);}}
            }
        }
        //----  NET
        if (fSet_ContinueNET()) {bb_OptimContinue = true; return (true);}
        //----  
        if (fSet_ContinueSARComplete()) {bb_OptimContinue = true; return (true);}
        //----  
        //if (TF_STOPs < TF_Indicators) {bb_OptimContinue = true; return (true);}
    }
    else {if (fSTOPTRADE()) return (true);}
    lb_Continue = false;
//----
    return (false);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+

